// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/CellFillingLevel.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/cell_filling_level__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `cell_size`
#include "rc_reason_msgs/msg/detail/rectangle__functions.h"
// Member `cell_position`
#include "geometry_msgs/msg/detail/point__functions.h"
// Member `level_in_percent`
// Member `level_free_in_meters`
#include "rc_reason_msgs/msg/detail/range_value__functions.h"

bool
rc_reason_msgs__msg__CellFillingLevel__init(rc_reason_msgs__msg__CellFillingLevel * msg)
{
  if (!msg) {
    return false;
  }
  // cell_size
  if (!rc_reason_msgs__msg__Rectangle__init(&msg->cell_size)) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
    return false;
  }
  // cell_position
  if (!geometry_msgs__msg__Point__init(&msg->cell_position)) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
    return false;
  }
  // level_in_percent
  if (!rc_reason_msgs__msg__RangeValue__init(&msg->level_in_percent)) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
    return false;
  }
  // level_free_in_meters
  if (!rc_reason_msgs__msg__RangeValue__init(&msg->level_free_in_meters)) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
    return false;
  }
  // coverage
  return true;
}

void
rc_reason_msgs__msg__CellFillingLevel__fini(rc_reason_msgs__msg__CellFillingLevel * msg)
{
  if (!msg) {
    return;
  }
  // cell_size
  rc_reason_msgs__msg__Rectangle__fini(&msg->cell_size);
  // cell_position
  geometry_msgs__msg__Point__fini(&msg->cell_position);
  // level_in_percent
  rc_reason_msgs__msg__RangeValue__fini(&msg->level_in_percent);
  // level_free_in_meters
  rc_reason_msgs__msg__RangeValue__fini(&msg->level_free_in_meters);
  // coverage
}

bool
rc_reason_msgs__msg__CellFillingLevel__are_equal(const rc_reason_msgs__msg__CellFillingLevel * lhs, const rc_reason_msgs__msg__CellFillingLevel * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // cell_size
  if (!rc_reason_msgs__msg__Rectangle__are_equal(
      &(lhs->cell_size), &(rhs->cell_size)))
  {
    return false;
  }
  // cell_position
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->cell_position), &(rhs->cell_position)))
  {
    return false;
  }
  // level_in_percent
  if (!rc_reason_msgs__msg__RangeValue__are_equal(
      &(lhs->level_in_percent), &(rhs->level_in_percent)))
  {
    return false;
  }
  // level_free_in_meters
  if (!rc_reason_msgs__msg__RangeValue__are_equal(
      &(lhs->level_free_in_meters), &(rhs->level_free_in_meters)))
  {
    return false;
  }
  // coverage
  if (lhs->coverage != rhs->coverage) {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__CellFillingLevel__copy(
  const rc_reason_msgs__msg__CellFillingLevel * input,
  rc_reason_msgs__msg__CellFillingLevel * output)
{
  if (!input || !output) {
    return false;
  }
  // cell_size
  if (!rc_reason_msgs__msg__Rectangle__copy(
      &(input->cell_size), &(output->cell_size)))
  {
    return false;
  }
  // cell_position
  if (!geometry_msgs__msg__Point__copy(
      &(input->cell_position), &(output->cell_position)))
  {
    return false;
  }
  // level_in_percent
  if (!rc_reason_msgs__msg__RangeValue__copy(
      &(input->level_in_percent), &(output->level_in_percent)))
  {
    return false;
  }
  // level_free_in_meters
  if (!rc_reason_msgs__msg__RangeValue__copy(
      &(input->level_free_in_meters), &(output->level_free_in_meters)))
  {
    return false;
  }
  // coverage
  output->coverage = input->coverage;
  return true;
}

rc_reason_msgs__msg__CellFillingLevel *
rc_reason_msgs__msg__CellFillingLevel__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__CellFillingLevel * msg = (rc_reason_msgs__msg__CellFillingLevel *)allocator.allocate(sizeof(rc_reason_msgs__msg__CellFillingLevel), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__CellFillingLevel));
  bool success = rc_reason_msgs__msg__CellFillingLevel__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__CellFillingLevel__destroy(rc_reason_msgs__msg__CellFillingLevel * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__CellFillingLevel__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__CellFillingLevel__Sequence__init(rc_reason_msgs__msg__CellFillingLevel__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__CellFillingLevel * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__CellFillingLevel *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__CellFillingLevel), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__CellFillingLevel__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__CellFillingLevel__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__CellFillingLevel__Sequence__fini(rc_reason_msgs__msg__CellFillingLevel__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__CellFillingLevel__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__CellFillingLevel__Sequence *
rc_reason_msgs__msg__CellFillingLevel__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__CellFillingLevel__Sequence * array = (rc_reason_msgs__msg__CellFillingLevel__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__CellFillingLevel__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__CellFillingLevel__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__CellFillingLevel__Sequence__destroy(rc_reason_msgs__msg__CellFillingLevel__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__CellFillingLevel__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__CellFillingLevel__Sequence__are_equal(const rc_reason_msgs__msg__CellFillingLevel__Sequence * lhs, const rc_reason_msgs__msg__CellFillingLevel__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__CellFillingLevel__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__CellFillingLevel__Sequence__copy(
  const rc_reason_msgs__msg__CellFillingLevel__Sequence * input,
  rc_reason_msgs__msg__CellFillingLevel__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__CellFillingLevel);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__msg__CellFillingLevel * data =
      (rc_reason_msgs__msg__CellFillingLevel *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__CellFillingLevel__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__CellFillingLevel__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__CellFillingLevel__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
