// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/DetectedTag.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/detected_tag__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `tag`
#include "rc_reason_msgs/msg/detail/tag__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"
// Member `instance_id`
#include "rosidl_runtime_c/string_functions.h"

bool
rc_reason_msgs__msg__DetectedTag__init(rc_reason_msgs__msg__DetectedTag * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
    return false;
  }
  // tag
  if (!rc_reason_msgs__msg__Tag__init(&msg->tag)) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
    return false;
  }
  // instance_id
  if (!rosidl_runtime_c__String__init(&msg->instance_id)) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__msg__DetectedTag__fini(rc_reason_msgs__msg__DetectedTag * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // tag
  rc_reason_msgs__msg__Tag__fini(&msg->tag);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
  // instance_id
  rosidl_runtime_c__String__fini(&msg->instance_id);
}

bool
rc_reason_msgs__msg__DetectedTag__are_equal(const rc_reason_msgs__msg__DetectedTag * lhs, const rc_reason_msgs__msg__DetectedTag * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // tag
  if (!rc_reason_msgs__msg__Tag__are_equal(
      &(lhs->tag), &(rhs->tag)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // instance_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->instance_id), &(rhs->instance_id)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__DetectedTag__copy(
  const rc_reason_msgs__msg__DetectedTag * input,
  rc_reason_msgs__msg__DetectedTag * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // tag
  if (!rc_reason_msgs__msg__Tag__copy(
      &(input->tag), &(output->tag)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // instance_id
  if (!rosidl_runtime_c__String__copy(
      &(input->instance_id), &(output->instance_id)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__msg__DetectedTag *
rc_reason_msgs__msg__DetectedTag__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__DetectedTag * msg = (rc_reason_msgs__msg__DetectedTag *)allocator.allocate(sizeof(rc_reason_msgs__msg__DetectedTag), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__DetectedTag));
  bool success = rc_reason_msgs__msg__DetectedTag__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__DetectedTag__destroy(rc_reason_msgs__msg__DetectedTag * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__DetectedTag__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__DetectedTag__Sequence__init(rc_reason_msgs__msg__DetectedTag__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__DetectedTag * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__DetectedTag *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__DetectedTag), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__DetectedTag__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__DetectedTag__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__DetectedTag__Sequence__fini(rc_reason_msgs__msg__DetectedTag__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__DetectedTag__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__DetectedTag__Sequence *
rc_reason_msgs__msg__DetectedTag__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__DetectedTag__Sequence * array = (rc_reason_msgs__msg__DetectedTag__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__DetectedTag__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__DetectedTag__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__DetectedTag__Sequence__destroy(rc_reason_msgs__msg__DetectedTag__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__DetectedTag__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__DetectedTag__Sequence__are_equal(const rc_reason_msgs__msg__DetectedTag__Sequence * lhs, const rc_reason_msgs__msg__DetectedTag__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__DetectedTag__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__DetectedTag__Sequence__copy(
  const rc_reason_msgs__msg__DetectedTag__Sequence * input,
  rc_reason_msgs__msg__DetectedTag__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__DetectedTag);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__msg__DetectedTag * data =
      (rc_reason_msgs__msg__DetectedTag *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__DetectedTag__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__DetectedTag__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__DetectedTag__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
