// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:msg/SilhouetteMatchObject.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__SILHOUETTE_MATCH_OBJECT__TRAITS_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__SILHOUETTE_MATCH_OBJECT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/msg/detail/silhouette_match_object__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rc_reason_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const SilhouetteMatchObject & msg,
  std::ostream & out)
{
  out << "{";
  // member: object_id
  {
    out << "object_id: ";
    rosidl_generator_traits::value_to_yaml(msg.object_id, out);
    out << ", ";
  }

  // member: region_of_interest_2d_id
  {
    out << "region_of_interest_2d_id: ";
    rosidl_generator_traits::value_to_yaml(msg.region_of_interest_2d_id, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SilhouetteMatchObject & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: object_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "object_id: ";
    rosidl_generator_traits::value_to_yaml(msg.object_id, out);
    out << "\n";
  }

  // member: region_of_interest_2d_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "region_of_interest_2d_id: ";
    rosidl_generator_traits::value_to_yaml(msg.region_of_interest_2d_id, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SilhouetteMatchObject & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::msg::SilhouetteMatchObject & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::msg::SilhouetteMatchObject & msg)
{
  return rc_reason_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::msg::SilhouetteMatchObject>()
{
  return "rc_reason_msgs::msg::SilhouetteMatchObject";
}

template<>
inline const char * name<rc_reason_msgs::msg::SilhouetteMatchObject>()
{
  return "rc_reason_msgs/msg/SilhouetteMatchObject";
}

template<>
struct has_fixed_size<rc_reason_msgs::msg::SilhouetteMatchObject>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::msg::SilhouetteMatchObject>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::msg::SilhouetteMatchObject>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__MSG__DETAIL__SILHOUETTE_MATCH_OBJECT__TRAITS_HPP_
