// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/SetLoadCarrier.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__SET_LOAD_CARRIER__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__SET_LOAD_CARRIER__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/srv/detail/set_load_carrier__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'load_carrier'
#include "rc_reason_msgs/msg/detail/load_carrier__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetLoadCarrier_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: load_carrier
  {
    out << "load_carrier: ";
    to_flow_style_yaml(msg.load_carrier, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetLoadCarrier_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: load_carrier
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "load_carrier:\n";
    to_block_style_yaml(msg.load_carrier, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetLoadCarrier_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::SetLoadCarrier_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::SetLoadCarrier_Request & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::SetLoadCarrier_Request>()
{
  return "rc_reason_msgs::srv::SetLoadCarrier_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::SetLoadCarrier_Request>()
{
  return "rc_reason_msgs/srv/SetLoadCarrier_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::SetLoadCarrier_Request>
  : std::integral_constant<bool, has_fixed_size<rc_reason_msgs::msg::LoadCarrier>::value> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::SetLoadCarrier_Request>
  : std::integral_constant<bool, has_bounded_size<rc_reason_msgs::msg::LoadCarrier>::value> {};

template<>
struct is_message<rc_reason_msgs::srv::SetLoadCarrier_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetLoadCarrier_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: return_code
  {
    out << "return_code: ";
    to_flow_style_yaml(msg.return_code, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetLoadCarrier_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: return_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "return_code:\n";
    to_block_style_yaml(msg.return_code, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetLoadCarrier_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::SetLoadCarrier_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::SetLoadCarrier_Response & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::SetLoadCarrier_Response>()
{
  return "rc_reason_msgs::srv::SetLoadCarrier_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::SetLoadCarrier_Response>()
{
  return "rc_reason_msgs/srv/SetLoadCarrier_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::SetLoadCarrier_Response>
  : std::integral_constant<bool, has_fixed_size<rc_common_msgs::msg::ReturnCode>::value> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::SetLoadCarrier_Response>
  : std::integral_constant<bool, has_bounded_size<rc_common_msgs::msg::ReturnCode>::value> {};

template<>
struct is_message<rc_reason_msgs::srv::SetLoadCarrier_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::SetLoadCarrier>()
{
  return "rc_reason_msgs::srv::SetLoadCarrier";
}

template<>
inline const char * name<rc_reason_msgs::srv::SetLoadCarrier>()
{
  return "rc_reason_msgs/srv/SetLoadCarrier";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::SetLoadCarrier>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::SetLoadCarrier_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::SetLoadCarrier_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::SetLoadCarrier>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::SetLoadCarrier_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::SetLoadCarrier_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::SetLoadCarrier>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::SetLoadCarrier_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::SetLoadCarrier_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__SET_LOAD_CARRIER__TRAITS_HPP_
