// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:msg/Compartment.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__COMPARTMENT__STRUCT_HPP_
#define RC_REASON_MSGS__MSG__DETAIL__COMPARTMENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'box'
#include "rc_reason_msgs/msg/detail/box__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__msg__Compartment __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__msg__Compartment __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Compartment_
{
  using Type = Compartment_<ContainerAllocator>;

  explicit Compartment_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_init),
    box(_init)
  {
    (void)_init;
  }

  explicit Compartment_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose(_alloc, _init),
    box(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;
  using _box_type =
    rc_reason_msgs::msg::Box_<ContainerAllocator>;
  _box_type box;

  // setters for named parameter idiom
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__box(
    const rc_reason_msgs::msg::Box_<ContainerAllocator> & _arg)
  {
    this->box = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::msg::Compartment_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::msg::Compartment_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::Compartment_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::msg::Compartment_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::Compartment_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::Compartment_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::msg::Compartment_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::msg::Compartment_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::Compartment_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::msg::Compartment_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__msg__Compartment
    std::shared_ptr<rc_reason_msgs::msg::Compartment_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__msg__Compartment
    std::shared_ptr<rc_reason_msgs::msg::Compartment_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Compartment_ & other) const
  {
    if (this->pose != other.pose) {
      return false;
    }
    if (this->box != other.box) {
      return false;
    }
    return true;
  }
  bool operator!=(const Compartment_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Compartment_

// alias to use template instance with default allocator
using Compartment =
  rc_reason_msgs::msg::Compartment_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__MSG__DETAIL__COMPARTMENT__STRUCT_HPP_
