// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:msg/LoadCarrierWithFillingLevel.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_WITH_FILLING_LEVEL__STRUCT_H_
#define RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_WITH_FILLING_LEVEL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'id'
#include "rosidl_runtime_c/string.h"
// Member 'outer_dimensions'
// Member 'inner_dimensions'
#include "rc_reason_msgs/msg/detail/box__struct.h"
// Member 'rim_thickness'
#include "rc_reason_msgs/msg/detail/rectangle__struct.h"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_stamped__struct.h"
// Member 'overall_filling_level'
// Member 'cells_filling_levels'
#include "rc_reason_msgs/msg/detail/cell_filling_level__struct.h"
// Member 'filling_level_cell_count'
#include "rc_reason_msgs/msg/detail/grid_size__struct.h"

/// Struct defined in msg/LoadCarrierWithFillingLevel in the package rc_reason_msgs.
/**
  * This represents a detected load carrier with it's filling level
 */
typedef struct rc_reason_msgs__msg__LoadCarrierWithFillingLevel
{
  rosidl_runtime_c__String id;
  /// Required
  rc_reason_msgs__msg__Box outer_dimensions;
  /// Required
  rc_reason_msgs__msg__Box inner_dimensions;
  /// Optional. If not provided, the rim thickness is computed from the outer and inner dimensions
  rc_reason_msgs__msg__Rectangle rim_thickness;
  geometry_msgs__msg__PoseStamped pose;
  /// True if a detected load carrier is overfilled. Ignored on setting load carrier.
  bool overfilled;
  /// Filling level of the whole load carrier
  rc_reason_msgs__msg__CellFillingLevel overall_filling_level;
  /// Filling level of each load carrier cell
  rc_reason_msgs__msg__CellFillingLevel__Sequence cells_filling_levels;
  rc_reason_msgs__msg__GridSize filling_level_cell_count;
} rc_reason_msgs__msg__LoadCarrierWithFillingLevel;

// Struct for a sequence of rc_reason_msgs__msg__LoadCarrierWithFillingLevel.
typedef struct rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence
{
  rc_reason_msgs__msg__LoadCarrierWithFillingLevel * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__msg__LoadCarrierWithFillingLevel__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__MSG__DETAIL__LOAD_CARRIER_WITH_FILLING_LEVEL__STRUCT_H_
