// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/DetectLoadCarriers.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__DETECT_LOAD_CARRIERS__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__DETECT_LOAD_CARRIERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__DetectLoadCarriers_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__DetectLoadCarriers_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DetectLoadCarriers_Request_
{
  using Type = DetectLoadCarriers_Request_<ContainerAllocator>;

  explicit DetectLoadCarriers_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : robot_pose(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_frame = "";
      this->region_of_interest_id = "";
    }
  }

  explicit DetectLoadCarriers_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : pose_frame(_alloc),
    region_of_interest_id(_alloc),
    robot_pose(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->pose_frame = "";
      this->region_of_interest_id = "";
    }
  }

  // field types and members
  using _pose_frame_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _pose_frame_type pose_frame;
  using _region_of_interest_id_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _region_of_interest_id_type region_of_interest_id;
  using _load_carrier_ids_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _load_carrier_ids_type load_carrier_ids;
  using _robot_pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _robot_pose_type robot_pose;

  // setters for named parameter idiom
  Type & set__pose_frame(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->pose_frame = _arg;
    return *this;
  }
  Type & set__region_of_interest_id(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->region_of_interest_id = _arg;
    return *this;
  }
  Type & set__load_carrier_ids(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->load_carrier_ids = _arg;
    return *this;
  }
  Type & set__robot_pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->robot_pose = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__DetectLoadCarriers_Request
    std::shared_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__DetectLoadCarriers_Request
    std::shared_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DetectLoadCarriers_Request_ & other) const
  {
    if (this->pose_frame != other.pose_frame) {
      return false;
    }
    if (this->region_of_interest_id != other.region_of_interest_id) {
      return false;
    }
    if (this->load_carrier_ids != other.load_carrier_ids) {
      return false;
    }
    if (this->robot_pose != other.robot_pose) {
      return false;
    }
    return true;
  }
  bool operator!=(const DetectLoadCarriers_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DetectLoadCarriers_Request_

// alias to use template instance with default allocator
using DetectLoadCarriers_Request =
  rc_reason_msgs::srv::DetectLoadCarriers_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.hpp"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__DetectLoadCarriers_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__DetectLoadCarriers_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct DetectLoadCarriers_Response_
{
  using Type = DetectLoadCarriers_Response_<ContainerAllocator>;

  explicit DetectLoadCarriers_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_init),
    return_code(_init)
  {
    (void)_init;
  }

  explicit DetectLoadCarriers_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : timestamp(_alloc, _init),
    return_code(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _timestamp_type =
    builtin_interfaces::msg::Time_<ContainerAllocator>;
  _timestamp_type timestamp;
  using _load_carriers_type =
    std::vector<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>>>;
  _load_carriers_type load_carriers;
  using _return_code_type =
    rc_common_msgs::msg::ReturnCode_<ContainerAllocator>;
  _return_code_type return_code;

  // setters for named parameter idiom
  Type & set__timestamp(
    const builtin_interfaces::msg::Time_<ContainerAllocator> & _arg)
  {
    this->timestamp = _arg;
    return *this;
  }
  Type & set__load_carriers(
    const std::vector<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::LoadCarrier_<ContainerAllocator>>> & _arg)
  {
    this->load_carriers = _arg;
    return *this;
  }
  Type & set__return_code(
    const rc_common_msgs::msg::ReturnCode_<ContainerAllocator> & _arg)
  {
    this->return_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__DetectLoadCarriers_Response
    std::shared_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__DetectLoadCarriers_Response
    std::shared_ptr<rc_reason_msgs::srv::DetectLoadCarriers_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DetectLoadCarriers_Response_ & other) const
  {
    if (this->timestamp != other.timestamp) {
      return false;
    }
    if (this->load_carriers != other.load_carriers) {
      return false;
    }
    if (this->return_code != other.return_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const DetectLoadCarriers_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DetectLoadCarriers_Response_

// alias to use template instance with default allocator
using DetectLoadCarriers_Response =
  rc_reason_msgs::srv::DetectLoadCarriers_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct DetectLoadCarriers
{
  using Request = rc_reason_msgs::srv::DetectLoadCarriers_Request;
  using Response = rc_reason_msgs::srv::DetectLoadCarriers_Response;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__DETECT_LOAD_CARRIERS__STRUCT_HPP_
