// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/GetLoadCarriers.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__GET_LOAD_CARRIERS__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__GET_LOAD_CARRIERS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/srv/detail/get_load_carriers__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetLoadCarriers_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: load_carrier_ids
  {
    if (msg.load_carrier_ids.size() == 0) {
      out << "load_carrier_ids: []";
    } else {
      out << "load_carrier_ids: [";
      size_t pending_items = msg.load_carrier_ids.size();
      for (auto item : msg.load_carrier_ids) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetLoadCarriers_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: load_carrier_ids
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.load_carrier_ids.size() == 0) {
      out << "load_carrier_ids: []\n";
    } else {
      out << "load_carrier_ids:\n";
      for (auto item : msg.load_carrier_ids) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetLoadCarriers_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::GetLoadCarriers_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::GetLoadCarriers_Request & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::GetLoadCarriers_Request>()
{
  return "rc_reason_msgs::srv::GetLoadCarriers_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::GetLoadCarriers_Request>()
{
  return "rc_reason_msgs/srv/GetLoadCarriers_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::GetLoadCarriers_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::GetLoadCarriers_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::GetLoadCarriers_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__traits.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const GetLoadCarriers_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: load_carriers
  {
    if (msg.load_carriers.size() == 0) {
      out << "load_carriers: []";
    } else {
      out << "load_carriers: [";
      size_t pending_items = msg.load_carriers.size();
      for (auto item : msg.load_carriers) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: return_code
  {
    out << "return_code: ";
    to_flow_style_yaml(msg.return_code, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const GetLoadCarriers_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: load_carriers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.load_carriers.size() == 0) {
      out << "load_carriers: []\n";
    } else {
      out << "load_carriers:\n";
      for (auto item : msg.load_carriers) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: return_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "return_code:\n";
    to_block_style_yaml(msg.return_code, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const GetLoadCarriers_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::GetLoadCarriers_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::GetLoadCarriers_Response & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::GetLoadCarriers_Response>()
{
  return "rc_reason_msgs::srv::GetLoadCarriers_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::GetLoadCarriers_Response>()
{
  return "rc_reason_msgs/srv/GetLoadCarriers_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::GetLoadCarriers_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::GetLoadCarriers_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::GetLoadCarriers_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::GetLoadCarriers>()
{
  return "rc_reason_msgs::srv::GetLoadCarriers";
}

template<>
inline const char * name<rc_reason_msgs::srv::GetLoadCarriers>()
{
  return "rc_reason_msgs/srv/GetLoadCarriers";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::GetLoadCarriers>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::GetLoadCarriers_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::GetLoadCarriers_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::GetLoadCarriers>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::GetLoadCarriers_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::GetLoadCarriers_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::GetLoadCarriers>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::GetLoadCarriers_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::GetLoadCarriers_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__GET_LOAD_CARRIERS__TRAITS_HPP_
