// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:srv/HandEyeCalibration.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/hand_eye_calibration__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

bool
rc_reason_msgs__srv__HandEyeCalibration_Request__init(rc_reason_msgs__srv__HandEyeCalibration_Request * msg)
{
  if (!msg) {
    return false;
  }
  // structure_needs_at_least_one_member
  return true;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Request__fini(rc_reason_msgs__srv__HandEyeCalibration_Request * msg)
{
  if (!msg) {
    return;
  }
  // structure_needs_at_least_one_member
}

bool
rc_reason_msgs__srv__HandEyeCalibration_Request__are_equal(const rc_reason_msgs__srv__HandEyeCalibration_Request * lhs, const rc_reason_msgs__srv__HandEyeCalibration_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // structure_needs_at_least_one_member
  if (lhs->structure_needs_at_least_one_member != rhs->structure_needs_at_least_one_member) {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__HandEyeCalibration_Request__copy(
  const rc_reason_msgs__srv__HandEyeCalibration_Request * input,
  rc_reason_msgs__srv__HandEyeCalibration_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // structure_needs_at_least_one_member
  output->structure_needs_at_least_one_member = input->structure_needs_at_least_one_member;
  return true;
}

rc_reason_msgs__srv__HandEyeCalibration_Request *
rc_reason_msgs__srv__HandEyeCalibration_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__HandEyeCalibration_Request * msg = (rc_reason_msgs__srv__HandEyeCalibration_Request *)allocator.allocate(sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request));
  bool success = rc_reason_msgs__srv__HandEyeCalibration_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Request__destroy(rc_reason_msgs__srv__HandEyeCalibration_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__HandEyeCalibration_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__init(rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__HandEyeCalibration_Request * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__HandEyeCalibration_Request *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__HandEyeCalibration_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__HandEyeCalibration_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__fini(rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__HandEyeCalibration_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence *
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * array = (rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__destroy(rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__are_equal(const rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * lhs, const rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__HandEyeCalibration_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence__copy(
  const rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * input,
  rc_reason_msgs__srv__HandEyeCalibration_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__HandEyeCalibration_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__srv__HandEyeCalibration_Request * data =
      (rc_reason_msgs__srv__HandEyeCalibration_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__HandEyeCalibration_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__HandEyeCalibration_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__HandEyeCalibration_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `message`
#include "rosidl_runtime_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"

bool
rc_reason_msgs__srv__HandEyeCalibration_Response__init(rc_reason_msgs__srv__HandEyeCalibration_Response * msg)
{
  if (!msg) {
    return false;
  }
  // success
  // status
  // message
  if (!rosidl_runtime_c__String__init(&msg->message)) {
    rc_reason_msgs__srv__HandEyeCalibration_Response__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    rc_reason_msgs__srv__HandEyeCalibration_Response__fini(msg);
    return false;
  }
  // error
  // translation_error_meter
  // rotation_error_degree
  // robot_mounted
  return true;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Response__fini(rc_reason_msgs__srv__HandEyeCalibration_Response * msg)
{
  if (!msg) {
    return;
  }
  // success
  // status
  // message
  rosidl_runtime_c__String__fini(&msg->message);
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // error
  // translation_error_meter
  // rotation_error_degree
  // robot_mounted
}

bool
rc_reason_msgs__srv__HandEyeCalibration_Response__are_equal(const rc_reason_msgs__srv__HandEyeCalibration_Response * lhs, const rc_reason_msgs__srv__HandEyeCalibration_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // success
  if (lhs->success != rhs->success) {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // message
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->message), &(rhs->message)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // error
  if (lhs->error != rhs->error) {
    return false;
  }
  // translation_error_meter
  if (lhs->translation_error_meter != rhs->translation_error_meter) {
    return false;
  }
  // rotation_error_degree
  if (lhs->rotation_error_degree != rhs->rotation_error_degree) {
    return false;
  }
  // robot_mounted
  if (lhs->robot_mounted != rhs->robot_mounted) {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__HandEyeCalibration_Response__copy(
  const rc_reason_msgs__srv__HandEyeCalibration_Response * input,
  rc_reason_msgs__srv__HandEyeCalibration_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // success
  output->success = input->success;
  // status
  output->status = input->status;
  // message
  if (!rosidl_runtime_c__String__copy(
      &(input->message), &(output->message)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // error
  output->error = input->error;
  // translation_error_meter
  output->translation_error_meter = input->translation_error_meter;
  // rotation_error_degree
  output->rotation_error_degree = input->rotation_error_degree;
  // robot_mounted
  output->robot_mounted = input->robot_mounted;
  return true;
}

rc_reason_msgs__srv__HandEyeCalibration_Response *
rc_reason_msgs__srv__HandEyeCalibration_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__HandEyeCalibration_Response * msg = (rc_reason_msgs__srv__HandEyeCalibration_Response *)allocator.allocate(sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response));
  bool success = rc_reason_msgs__srv__HandEyeCalibration_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Response__destroy(rc_reason_msgs__srv__HandEyeCalibration_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__HandEyeCalibration_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__init(rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__HandEyeCalibration_Response * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__HandEyeCalibration_Response *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__HandEyeCalibration_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__HandEyeCalibration_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__fini(rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__HandEyeCalibration_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence *
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * array = (rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__destroy(rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__are_equal(const rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * lhs, const rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__HandEyeCalibration_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence__copy(
  const rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * input,
  rc_reason_msgs__srv__HandEyeCalibration_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__HandEyeCalibration_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__srv__HandEyeCalibration_Response * data =
      (rc_reason_msgs__srv__HandEyeCalibration_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__HandEyeCalibration_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__HandEyeCalibration_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__HandEyeCalibration_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
